package es.ejie.frmk.control.apilamiento;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;

import org.apache.commons.beanutils.DynaProperty;

import es.ejie.frmk.presentacion.sesiondatos.Q70ContextoEJIE;
import es.ejie.frmk.presentacion.sesiondatos.Q70ContextoEJIEDynaClass;
import es.ejie.frmk.presentacion.sesiondatos.Q70SesionDatos;

/**
 * Esta clase representa la estructura de datos que apila/desapila el Gestor de
 * Apilamiento.
 * 
 * @version 1.0
 * Fecha: 15-dic-03
 */
public class Q70EstructuraDialogo implements Serializable {

	/**
	 * Hash que se utilizará como clave primaria cunado se haga un apilamiento
	 * remoto.
	 */
	private String hash = null;
	/**
	 * Contexto de la operación que queremos apilar/desapilar en las suboperaciones locales
	 */
	private Q70ContextoEJIE contexto = null;
	/**
	 * Lista de atributos que queremos apilar/desapilar
	 */
	private Collection listaAtributos = new HashSet(11);
	private Collection listaNombresAtributos = new HashSet(11);	
	/**
	 * Path al que retornar al finalizar la suboperación
	 */
	private String retPath = null;

	/**
	 * Indica de que versión de Geremua procede la superoperacion que la invoco o 
	 * la suboperacion invocada.
	 */
	private boolean posteriorVersionUno = true;
	
	/**
	 * @return
	 */
	public String getHash() {
		return hash;
	}

	/**
	 * @param string
	 */
	public void setHash(String string) {
		hash = string;
	}

	/**
	 * @return Contexto de la operación apilada.
	 */
	public Q70ContextoEJIE getContexto() {
		return contexto;
	}
	
	/**
	 * @param Contexto de la operación que queremos
	 * apilar/desapilar.
	 */
	public void setContexto(Q70ContextoEJIE contexto) {
		this.contexto = contexto;		
		listaAtributos.clear();
	}

	/*
	 * Recorre el contexto y va annadiendo a la lista (si no existe se crea) 
	 */
	private void setListaAtributosContexto(Q70ContextoEJIE contextoAux, DynaProperty[] dynaPropertiesArray) {
		DynaProperty dynaProperty = null;
		
		for (int i=0;i<dynaPropertiesArray.length;i++){
			ArrayList listaAtributo = new ArrayList(2);
			dynaProperty = dynaPropertiesArray[i];
			listaAtributo.add(dynaProperty.getName());
			listaAtributo.add(contextoAux.get(dynaProperty.getName()));

			if (!listaNombresAtributos.contains(dynaProperty.getName())){
				listaAtributos.add(listaAtributo);				
				listaNombresAtributos.add(dynaProperty.getName());				
			}
		}
	}

	/**
	 * @return Path al que retornar al finalizar la suboperación.
	 */
	public String getRetPath() {
		return retPath;
	}

	/**
	 * @param Path al que retornar al finalizar la suboperación.
	 */
	public void setRetPath(String pathDeRetorno) {
		this.retPath = pathDeRetorno;
	}

	/**
	 * @return Lista de atributos de la operación apilada.
	 */
	public Collection getListaAtributos() {
		
		if (listaAtributos.isEmpty()){
			Q70ContextoEJIE contextoAux;
			
			//Recorro contexto de OP y annado a la lista
			//Recorro en primer lugar este contexto (OP) porque si un atributo esta en los dos contextos
			//me interesa el valor del de OP
			contextoAux = Q70SesionDatos.getSingleton().getContexto(contexto, Q70SesionDatos.CTX_OPERACION_PRESENTACION);
			setListaAtributosContexto(contextoAux, ((Q70ContextoEJIEDynaClass) contextoAux.getDynaClass()).getPropiedadesDePrimerNivel());
			
			contextoAux = Q70SesionDatos.getSingleton().getContexto(contexto, Q70SesionDatos.CTX_APLICACION);
			//Recorro contexto de aplicacion y annado a la lista
			setListaAtributosContexto(contextoAux, contextoAux.getDynaClass().getDynaProperties());			
		}
		return listaAtributos;
	}

	/**
	 * @param Lista de atributos de la operación que queremos
	 * apilar/desapilar.
	 */
	public void setListaAtributos(Collection listaAtributos) {
		this.listaAtributos = listaAtributos;
	}
	
	/**
	 * Método que muestra formateados los datos de la Clase 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "ESTRUCTURA DE DIALOGO:Path de retorno:'"+this.retPath+"';Hash:'"+((null == this.hash)?"NULL":this.hash.toString())+"';Version Geremua es posterior a la primera:'"+isPosteriorVersionUno()+"'";
	}

	public boolean isPosteriorVersionUno() {
		return posteriorVersionUno;
	}

	public void setPosteriorVersionUno(boolean posteriorVersionUno) {
		this.posteriorVersionUno = posteriorVersionUno;
	}
}
